//+------------------------------------------------------------------+
//|                                                          HLR.mq4 |
//|                                      Copyright  2007, Alexandre |
//|                      http://www.kroufr.ru/content/view/1184/124/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Alexandre"
#property link      "http://www.kroufr.ru/content/view/1184/124/"
//----
#property indicator_separate_window
#property indicator_buffers 3 
#property indicator_minimum 0 
#property indicator_maximum 100
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Red
#property indicator_level1 10
#property indicator_level2 50
#property indicator_level3 90
//---- input parameters
extern int  HLR_Range = 40;
extern int TimeFrame;
//---- buffers
double HLR_Buffer[];
double UP[];
double DOWN[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(HLR_Range <= 1) 
       HLR_Range = 1; 
//---- indicators
   IndicatorShortName("Hi-Lo Range Oscillator (" + HLR_Range + ")"); 
   SetLevelStyle(STYLE_DASHDOT, 1, DodgerBlue); 
   SetIndexStyle(0, DRAW_LINE); 
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexLabel(0, "HLR"); 
   SetIndexBuffer(0, HLR_Buffer);
   SetIndexBuffer(1, UP); 
   SetIndexBuffer(2, DOWN); 
   SetIndexDrawBegin(0, HLR_Range); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars=IndicatorCounted();
     if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if(TimeFrame!=Period())
            limit = MathMax(limit,TimeFrame/Period());

   for(i = limit; i >= 0; i--)
     {  int y = iBarShift(NULL,TimeFrame,Time[i]);
        int bug1 = iHighest(NULL, TimeFrame, MODE_HIGH, HLR_Range, y);
        int bug2 = iLowest(NULL, TimeFrame, MODE_LOW,  HLR_Range, y);
       double hhv  = iHigh(NULL, TimeFrame,bug1);
       double llv  =  iLow(NULL, TimeFrame,bug2); 
       double m_pr = (High[i] + Low[i]) / 2.0; 
       HLR_Buffer[i] = 100.0 * (m_pr - llv) / (hhv - llv); 
       if (HLR_Buffer[i] < 6)      UP[i] = 100;
         if (HLR_Buffer[i] > 96)    DOWN[i] = 100;
     } 
   return(0);
}

